import React, { Component, Fragment } from "react";
import {
    Form,
    Select,
    Input,
    Radio,
    Button,
    Checkbox,
    Row,
    Col,
    Switch,
    message,
    InputNumber,
    Modal
} from "antd";
import ItemUpload from "./components/ItemUpload/ItemUpload";
import ItemRadioSelect from "./components/ItemRadioSelect/ItemRadioSelect";
import ItemSelectPlus from "./components/ItemSelectPlus";
import ItemLoginMethod from "./components/ItemLoginMethod";
import ItemFunctionSwitches from "./components/ItemFunctionSwitches";
import ItemProductList from "./components/ItemProductList";
const { Option } = Select;
const { TextArea } = Input;
const { confirm } = Modal;
class FormTpl extends Component {
    constructor(props) {
        super(props);
    }
    formItemLayout;
    handleSubmit = (e) => {
        e.preventDefault();
        this.props.form.validateFields((errs, values) => {
            // product_list = product_list.filter(element => element.price && element.product_id);
            // values.product_list = product_list;
            if (errs) {
                for(let i in errs){
                    if(errs[i].errors){
                        errs[i].errors.forEach(e => message.error(e.message) )
                    }
                    return
                }
            }else{
                let product_list = values.product_list;
                if(product_list && product_list.length > 0){
                    let content = "请填写完整";
                    product_list.forEach((element)=>{
                        if(!element.price && element.product_id) {
                            content = content + element.product_id + ":";
                        }else if(!element.product_id && element.price) {
                            content = content + ":" + element.price;
                        } else if(!element.price && !element.product_id) {
                            content = content + ":";
                        }
                    })     
                    let flag =  product_list.some((element)=>{
                        return !element.price || !element.product_id;
                    })
                    if(flag){
                        this.showConfirm(content);
                        return;
                    }
                }
                this.props.getReqParams(values);
            }
        });
    };
    showConfirm = (contentStr) => {
        confirm({
            title: '提示',
            content: contentStr,
            onOk() {
            return new Promise((resolve, reject) => {
                setTimeout(Math.random() > 0.5 ? resolve : reject, 1000);
            }).catch(() => console.log('Oops errors!'));
            },
            onCancel() {},
        });
    }
    handleReset = () => {
        this.props.form.resetFields();
    };
    normFile = e => {
        console.log("Upload event:", e);
        if (Array.isArray(e)) {
            return e;
        }
        return e && e.fileList;
    };

    render() {
        const { getFieldDecorator } = this.props.form;
        const radioLayout = {
            labelCol: {
                xs: { span: 5 },
                sm: { span: 5 }
            },
            wrapperCol: {
                xs: { span: 12 },
                sm: { span: 12 }
            }
        };
        if (!this.props.formItemLayout) {
            this.formItemLayout = {
                labelCol: {
                    xs: { span: 5 },
                    sm: { span: 5 }
                },
                wrapperCol: {
                    xs: { span: 16 },
                    sm: { span: 16 }
                }
            };
        } else {
            this.formItemLayout = this.props.formItemLayout;
        }
        return (
            <Form onSubmit={this.handleSubmit}>
                {this.props.config.map((item, i) => {
                    switch (item.type) {
                        case "input":
                            return (
                                <Form.Item
                                    key={i}
                                    {...this.formItemLayout}
                                    label={item.label}
                                    className="mr-20"
                                >
                                    {getFieldDecorator(item.key, {
                                        initialValue: this.props.dataSource ? this.props.dataSource[item.key] : undefined,
                                        rules: [
                                            {
                                                required: item.required,
                                                message: "缺少" + item.label
                                            }
                                        ]
                                    })(
                                        <Input
                                            placeholder={item.placeholder}
                                            disabled={item.disabled || false}
                                            readOnly={item.readOnly || false}
                                        />
                                    )}
                                    {(() => {
                                        if (!!item.explain) {
                                            return <p>{item.explain}</p>;
                                        } else {
                                            return null;
                                        }
                                    })()}
                                </Form.Item>
                            );
                        case "password":
                            return (
                                <Form.Item
                                    key={i}
                                    {...this.formItemLayout}
                                    label={item.label}
                                    className="mr-20"
                                >
                                    {getFieldDecorator(item.key, {
                                        initialValue: this.props.dataSource ? this.props.dataSource[item.key] : undefined,
                                        rules: [
                                            {
                                                required: item.required,
                                                message: "缺少" + item.label
                                            }
                                        ]
                                    })(
                                        <Input.Password
                                            placeholder={item.placeholder}
                                            disabled={item.disabled || false}
                                            readOnly={item.readOnly || false}
                                        />
                                    )}
                                    {(() => {
                                        if (!!item.explain) {
                                            return <p>{item.explain}</p>;
                                        } else {
                                            return null;
                                        }
                                    })()}
                                </Form.Item>
                            );
                        case "inputNumber":
                            return (
                                <Form.Item
                                    key={i}
                                    {...this.formItemLayout}
                                    label={item.label}
                                    className="mr-20"
                                >
                                    {getFieldDecorator(item.key, {
                                        initialValue: this.props.dataSource ? this.props.dataSource[item.key] : undefined,
                                        rules: [
                                            {
                                                required: item.required,
                                                message: "缺少" + item.label
                                            }
                                        ]
                                    })(
                                        <InputNumber
                                            placeholder={item.placeholder}
                                            disabled={item.disabled || false}
                                            readOnly={item.readOnly || false}
                                        />
                                    )}
                                    {(() => {
                                        if (!!item.explain) {
                                            return <p>{item.explain}</p>;
                                        } else {
                                            return null;
                                        }
                                    })()}
                                </Form.Item>
                            );
                        case "select":
                            return (
                                <Form.Item {...this.formItemLayout} label={item.label} key={i}>
                                    {getFieldDecorator(item.key, {
                                        initialValue: this.props.dataSource ? this.props.dataSource[item.key] : undefined,
                                        rules: [{ required: item.required, message: item.error }]
                                    })(
                                        <Select
                                            placeholder={item.placeholder}
                                            onChange={item.onChange || undefined}
                                        >
                                            {item.data.map((data, index) => {
                                                if (item.name_value_label) {
                                                    return <Option value={data.id}>{data.name} <i>{data.id}</i></Option>;
                                                } else {
                                                    return <Option value={data.id}>{data.name}</Option>;
                                                }
                                            })}
                                        </Select>
                                    )}
                                    {(() => {
                                        if (!!item.explain) {
                                            return <p>{item.explain}</p>;
                                        } else {
                                            return null;
                                        }
                                    })()}
                                </Form.Item>
                            );
                        case "select_multiple":
                        return (
                          <Form.Item {...item.formItemLayout || this.formItemLayout} label={item.label} key={i}>
                            {getFieldDecorator(item.key, {
                              initialValue: this.props.dataSource ? this.props.dataSource[item.key] : undefined,
                              rules: [{ required: item.required, message: item.error }]
                            })(
                              <Select
                                placeholder={item.placeholder}
                                onChange={item.onChange || undefined}
                                mode="multiple"
                              >
                                {
                                  item.data.map((data, index) => {
                                  return <Option value={data.id}>{data.name}</Option>;
                                })}
                              </Select>
                            )}
                            {(() => {
                              if (!!item.explain) {
                                return <p>{item.explain}</p>;
                              } else {
                                return null;
                              }
                            })()}
                          </Form.Item>
                        );
                        case "checkbox":
                            return (
                                <Form.Item label={item.label} {...radioLayout}
                                    key={i}
                                >
                                    {getFieldDecorator(item.key, {
                                        initialValue: this.props.dataSource[item.key]
                                            ? this.props.dataSource[item.key]
                                            : undefined,
                                        rules: [
                                            {
                                                required: item.required,
                                                message: "缺少" + item.label
                                            }
                                        ]
                                    })(
                                        <Checkbox.Group
                                            style={{ width: "100%", marginTop: "10px" }}
                                        >
                                            <Row>
                                                {item.data.map((data, index) => {
                                                    if (!item.canAdd) {
                                                        if (this.props.dataSource && this.props.dataSource[item.key].indexOf(data.id) > -1) {
                                                            return (
                                                                <Col span={3}>
                                                                    <Checkbox value={data.id}>
                                                                        {data.name}
                                                                    </Checkbox>
                                                                </Col>
                                                            );
                                                        } else {
                                                            return (
                                                                <Col span={3}>
                                                                    <Checkbox value={data.id} disabled>
                                                                        {data.name}
                                                                    </Checkbox>
                                                                </Col>
                                                            );
                                                        }
                                                    } else {
                                                        if (
                                                            this.props.dataSource[
                                                                item.key
                                                            ].initialValue.indexOf(data.id) > -1
                                                        ) {
                                                            return (
                                                                <Col span={3}>
                                                                    <Checkbox value={data.id} disabled>
                                                                        {data.name}
                                                                    </Checkbox>
                                                                </Col>
                                                            );
                                                        } else {
                                                            return (
                                                                <Col span={3}>
                                                                    <Checkbox value={data.id}>
                                                                        {data.name}
                                                                    </Checkbox>
                                                                </Col>
                                                            );
                                                        }
                                                    }
                                                })}
                                            </Row>
                                        </Checkbox.Group>
                                    )}
                                </Form.Item>
                            );
                        case "radio":
                            return (
                                <Form.Item label={item.label} {...this.formItemLayout}
                                    key={i}
                                >
                                    {getFieldDecorator(item.key, {
                                        initialValue: this.props.dataSource ? this.props.dataSource[item.key] : undefined,
                                        rules: [
                                            {
                                                required: item.required,
                                                message: "缺少" + item.label
                                            }
                                        ]
                                    })(
                                        <Radio.Group onChange={item.onChange || undefined}>
                                            {item.data.map((data, index) => {
                                                return <Radio value={data.id}>{data.name}</Radio>;
                                            })}
                                        </Radio.Group>
                                    )}
                                    {(() => {
                                        if (!!item.explain) {
                                            return <p>{item.explain}</p>;
                                        } else {
                                            return null;
                                        }
                                    })()}
                                </Form.Item>
                            );
                        case "switch":
                            return (
                                <Form.Item label={item.label} {...this.formItemLayout}
                                    key={i}
                                >
                                    {getFieldDecorator(item.key, {
                                        initialValue: this.props.dataSource ? this.props.dataSource[item.key] == 1 : false,
                                        valuePropName: "checked", //https://github.com/ckinmind/antd-react-demo/issues/17
                                        rules: [
                                            {
                                                required: item.required,
                                                message: "缺少" + item.label
                                            }
                                        ],
                                        getValueFromEvent(e) {
                                            return e === true ? 1 : 0;
                                        }
                                    })(<Switch />)}
                                </Form.Item>
                            );
                        case "upload":
                            return (
                                <Form.Item label={item.label} {...this.formItemLayout}
                                    key={i}
                                >
                                    {getFieldDecorator(item.key, {
                                        initialValue: this.props.dataSource ? this.props.dataSource[item.key] : undefined,
                                        rules: [
                                            {
                                                required: item.required,
                                                message: "缺少" + item.label
                                            }
                                        ],
                                    })(
                                        <ItemUpload />
                                    )}
                                </Form.Item>
                            );
                        case "text":
                            return (
                                <Form.Item label={item.label} {...this.formItemLayout}
                                    key={i}
                                >
                                    {getFieldDecorator(item.key, {
                                        initialValue:
                                            this.props.dataSource[item.key] && item.translation_map
                                                ? item.translation_map[this.props.dataSource[item.key]]
                                                : this.props.dataSource[item.key]
                                    })(
                                        <Input
                                            placeholder={item.placeholder}
                                            style={{
                                                border: "none",
                                                backgroundColor: "transparent",
                                                color: "#565656"
                                            }}
                                            disabled
                                        />
                                    )}
                                </Form.Item>
                            );
                        case "plain-text":
                            return (
                                <Form.Item label={item.label} {...this.formItemLayout}
                                    key={i}
                                >
                                    <span className="ant-form-text">
                                        {this.props.dataSource[item.key] && item.translation_map
                                            ? item.translation_map[this.props.dataSource[item.key]]
                                            : this.props.dataSource[item.key]}
                                    </span>
                                </Form.Item>
                            );
                        case "icon":
                            return (
                                <Form.Item label={item.label} {...this.formItemLayout}
                                    key={i}
                                >
                                    {getFieldDecorator(item.key, {
                                        initialValue: this.props.dataSource
                                            ? this.props.dataSource[item.key]
                                            : null
                                    })(
                                        <Fragment>
                                            <img
                                                style={{ height: "100px" }}
                                                src={
                                                    this.props.dataSource
                                                        ? this.props.dataSource[item.key]
                                                        : null
                                                }
                                                alt=""
                                            />
                                        </Fragment>
                                    )}
                                </Form.Item>
                            );
                        case "textarea":
                            return (
                                <Form.Item {...this.formItemLayout} label={item.label}
                                    key={i}
                                >
                                    {getFieldDecorator(item.key, {
                                        initialValue: this.props.dataSource ? this.props.dataSource[item.key] : undefined,
                                        rules: [
                                            {
                                                required: item.required,
                                                message: "缺少" + item.label
                                            }
                                        ]
                                    })(<TextArea rows={4} placeholder={item.placeholder} />)}
                                </Form.Item>
                            );
                        case "radio_select":
                            return (
                                <ItemRadioSelect form={this.props.form} dataSource={this.props.dataSource} item={item} formItemLayout={this.formItemLayout}
                                    key={i}
                                />
                            );
                        case "tpl":
                            return (
                                <Form.Item
                                    key={i}
                                    wrapperCol={{ offset: 4 }}>{item.render}</Form.Item>
                            );
                        case "origin":
                            return <Fragment
                                key={i}
                            >{item.render}</Fragment>;
                        case "select_plus":
                            return (
                                <ItemSelectPlus
                                    key={i}
                                    form={this.props.form}
                                    item={item}
                                    formItemLayout={this.formItemLayout}
                                    getParams={this.props.getParams}
                                    getRadioData={this.props.getRadioData}
                                />
                            );
                        case "login_methods":
                            return (
                                <Form.Item
                                    key={i}
                                    {...this.formItemLayout}
                                    label={item.label}
                                    className="mr-20"
                                >
                                    {getFieldDecorator(item.key, {
                                        initialValue: this.props.dataSource[item.key] || [],
                                        rules: [
                                            {
                                                validator: (rule, value, callback) => {
                                                    // if (value.length > 7) {
                                                    //     callback("登录方式不可超过7种，请重新配置");
                                                    //     return
                                                    // }
                                                    for (let item of value) {
                                                        if (item.type == 'guest' || item.type == 'account' ||item.type == 'citation') {
                                                            continue
                                                        }

                                                        let idPlaceholder = 'APP ID';
                                                        let secretPlaceholder = 'APP SECRET';
                                                        switch (item.type) {
                                                            case 'google':
                                                                idPlaceholder = 'Google_SERVER_CLIENT_ID';
                                                                break;
                                                            case 'facebook':
                                                                idPlaceholder = 'FACEBOOK_ID';
                                                                secretPlaceholder = 'FACEBOOK_KEY';
                                                                break;
                                                            case 'naver':
                                                                idPlaceholder = 'NV_clinet_ID';
                                                                secretPlaceholder = 'NV_clinet_SECRET';
                                                                break;
                                                            case 'line':
                                                                idPlaceholder = 'Channel ID';
                                                                secretPlaceholder = 'Channel Secret';
                                                                break;
                                                            case 'twitter':
                                                              idPlaceholder = 'Custom key';
                                                              secretPlaceholder = 'Custom Secret';
                                                              break
                                                        }

                                                        if (item.type != 'google' && item.type != 'apple'&& item.type != 'citation') {
                                                            if (!item.app_key) {
                                                                callback(item.name + idPlaceholder + '不能为空');
                                                                return
                                                            }
                                                        }

                                                        if (!item.app_id) {
                                                            callback(item.name + secretPlaceholder + '不能为空');
                                                            return
                                                        }
                                                    }
                                                    callback()
                                                }
                                            }
                                        ]
                                    })(<ItemLoginMethod />)}
                                </Form.Item>
                            );
                        case "function_switches":
                            return (
                                // item.label.map((value, index)=>{
                                //     return <Form.Item
                                //         key={index}
                                //         {...this.formItemLayout}
                                //         label={value}
                                //         >
                                //         {getFieldDecorator(item.key, {
                                //             initialValue: this.props.dataSource[item.key] || {}
                                //         })(<ItemFunctionSwitches />)}
                                //     </Form.Item>
                                // })
                                <Form.Item
                                    key={i}
                                    // {...this.formItemLayout}
                                    // label={item.label[0]}
                                    className="mr-20"
                                >
                                    {getFieldDecorator(item.key, {
                                        initialValue: this.props.dataSource[item.key] || {}
                                    })(<ItemFunctionSwitches />)}
                                </Form.Item>
                            );
                        case "pay_switches":
                            return (
                                <Form.Item
                                    key={i}
                                    className="mr-20"
                                >
                                    {getFieldDecorator(item.key, {
                                        initialValue: this.props.dataSource[item.key] || {}
                                    })(<ItemFunctionSwitches />)}
                                </Form.Item>
                            );
                        case "product_list":
                            return (
                                <Form.Item
                                    key={i}
                                  {...this.formItemLayout}
                                  label={item.label}
                                    className="mr-20"
                                >
                                  {getFieldDecorator(item.key, {
                                      initialValue: this.props.dataSource[item.key]
                                  })(<ItemProductList />)}
                                </Form.Item>
                            );
                        case "submit":
                            return (
                                <Form.Item wrapperCol={{ span: 12, offset: 4 }}
                                    key={i}
                                >
                                    {(() => {
                                        switch (item.extend) {
                                            case true:
                                                return item.render;
                                            default:
                                                return (
                                                    <Fragment>
                                                        <Button
                                                            type="primary"
                                                            htmlType="submit"
                                                            className="mr-20"
                                                        >
                                                            提交
                                                            </Button>
                                                        <Button onClick={this.handleReset}>重置</Button>
                                                    </Fragment>
                                                );
                                        }
                                    })()}
                                </Form.Item>
                            );
                    }
                })}
            </Form>
        );
    }
}
const ItemForm = Form.create({ name: "validate_other" })(FormTpl);
export default ItemForm;
