import React,{Fragment} from 'react';
import moment from 'moment';
import { withRouter } from "react-router-dom";
import ItemNav from "../../components/ItemNav";
import ItemTableQuery from "../../components/ItemTableQuery";
import ItemTable from "../../components/ItemTable";
import HttpClient from "../../service/HttpClient";
import Api from "../../service/Api";
import { set, get,downloadExcel } from "../../service/Global";
import {Tag, Button, Empty, Modal, Table, Input,Form, Select} from 'antd';
import {dateFormat, parseParams} from "../../service/utils";
import {Store} from "marine";
const { TextArea } = Input;
@withRouter
 class QueryPlayer extends React.Component{
  constructor(props){
    super(props);
    this.state={
      visible: false,
      platData:[],
      channelData:[],
      currencyData:[],
      dataSource:{},
    }
  }
  form;
  defaultParams = {
    page:1,
    pageSize:10
  };
  itemNav = {
    list: [{ anchor: "玩家管理" }],
  };
  columns = [
    { title: "玩家ID", dataIndex: "uid", key: "uid",},
    { title: "平台名称", dataIndex: "platformName", key: "platformName"},
    { title: "渠道名称", dataIndex: "channelName", key: "channelName" },
    { title: "原来数量", dataIndex: "beforeNum", key: "beforeNum" },
    { title: "日志类型", dataIndex: "typeName", key: "typeName", },
    { title: "变化量", dataIndex: "optionNum", key: "optionNum"},
    { title: "现在数量", dataIndex: "afterNum", key: "afterNum",},
    { title: "来源", dataIndex: "source", key: "source",},
    { title: "日志时间", dataIndex: "logTime", key: "logTime"},
  ];

  getList(params){
    return HttpClient.post(Api.logList,{...params}).then(data => {
      this.setState({
        dataSource: data,
      })
    })
  }

  getPlatList(){
    return HttpClient.post(Api.platformList).then(data => {
      let tmp=[]
      for(var i in data){
        let obj= {id:i,name:data[i]}
          tmp.push(obj)
        
      }
      this.setState({
        platData:tmp
      })
    })
  }
  channelList=()=>{
    return HttpClient.post(Api.channelList).then(data => {
      let tmp=[]
      for(var i in data){
        let obj= {id:i,name:data[i]}
        tmp.push(obj)
      }
      this.setState({
        channelData:tmp
      })
    })
  }
  currencyList=()=>{
    return HttpClient.post(Api.currencyList).then(data => {
      let tmp=[]
      for(var i in data){
        let obj= {id:i,name:data[i]}
        tmp.push(obj)
      }
      this.setState({
        currencyData:tmp
      })
    })
  }
  
  pager = (page) => {
    this.defaultParams = Object.assign({},this.defaultParams,{page_index:page});
    this.getList(this.defaultParams);
  };
  getTableQuery=(params)=>{
    if(params['range_picker']){
      console.log(params['range_picker'])
      const [startTime,endTime] = params['range_picker'];
      this.defaultParams = Object.assign(this.defaultParams,{startTime,endTime},{...params});
    }else {
      this.defaultParams = Object.assign(this.defaultParams,{...params});
    }
    delete this.defaultParams.range_picker;
    this.getList(this.defaultParams);
  };
  resetParams = ()=>{
    this.defaultParams = {};
    this.setState({
      tableData:{}
    })
  };

 
  getExcel = () => {
    const {data}=this.state.dataSource.data?this.state.dataSource:{};
    downloadExcel(data,'玩家管理', ["uid","platformName","channelName","beforeNum","typeName","optionNum","afterNum","source","logTime"],["玩家ID","平台名称","渠道名称","原来数量","日志类型","变化量","现在数量","来源","日志时间",])
  };
 
  showBatchModal = () => {
    this.setState({visible: true,});
  };
 

  componentDidMount() {
    this.getPlatList();
    this.channelList();
    this.currencyList();
    this.getList(this.defaultParams)
  }

  render() {
    const {platData,channelData,currencyData}=this.state;
    const itemTableQuery= [
         
      {
        label:'选择日期',
        type: "range_picker",
        key: "date",   

      },
      {
        label:'所属平台',
        type:'select',
        key:'platform',
       // mode:'multiple',
        defaultValue:platData.length>0?'0':'',
        data:platData,
          
      },
      {
        label:'所属渠道',
        type:'select',
        key:'channel',
        defaultValue:channelData.length>0?'0':'',
        data:channelData,
          
      },
      {
        label:'日志类型',
        type:'select',
        key:'logType',
        //placeholder:'全部',
        data:[
          {name:'货币产出',id:1},
          {name:'货币消耗',id:2},
          ],
          
      },
      {
        label:'货币类型',
        type:'select',
        key:'type',
        defaultValue:currencyData.length>0?'0':'',
        data:currencyData,
          
      },
      {
        type:'input',
        key:'uid',
       placeholder:'请输入玩家ID'
      },
     
      {
        type: "submit",
        extend: false,
        render: <Fragment>
        <Button type='default' className='ml-20 export' onClick={()=> this.getExcel()}>导出</Button>
       </Fragment>,
        }
    ];
   
   
    return(
      <Fragment>
            <ItemNav itemNav={this.itemNav} />
            <section className='content-base'>
          <div className='mb-20'>
           <ItemTableQuery getTableQuery={this.getTableQuery} resetParams={this.resetParams} itemTableQuery={itemTableQuery} />
            
          </div>
         
          <ItemTable columns={this.columns} dataSource={this.state.dataSource} pager={this.pager} />
        </section>
       
      </Fragment>
    )
  }
}
export default Form.create()(QueryPlayer)