import React,{Fragment} from 'react';
import moment from 'moment';
import { withRouter } from "react-router-dom";
import ItemNav from "../../components/ItemNav";
import ItemTableQuery from "../../components/ItemTableQuery";
import ItemTable from "../../components/ItemTable";
import HttpClient from "../../service/HttpClient";
import Api from "../../service/Api";
import { set, get } from "../../service/Global";
import {Tag, Button, Empty, Modal, Table, Input,Form, Popconfirm,message} from 'antd';
import {dateFormat, parseParams} from "../../service/utils";
import {Store} from "marine";
const { TextArea } = Input;
@withRouter
 class User extends React.Component{
  constructor(props){
    super(props);
    this.state={
      visible: false,
      visible_edit:false,
    title:'新增用户',
      list:{},
      dataSource:{},
    }
  }
  form;
  defaultParams = {
   page:1,
   pageSize:10
  };
  itemNav = {
    list: [{ anchor: "用户管理" }],
  };
  columns = [
    { title: "姓名", dataIndex: "name", key: "name" },
    { title: "真实姓名", dataIndex: "realName", key: "realName"},
    { title: "手机号", dataIndex: "phone", key: "phone",},
    { title: "邮箱", dataIndex: "email", key: "email", },
    { title: "创建时间", dataIndex: "created_at", key: "created_at",},
    { title: "操作", dataIndex: "operate", key: "operate",render:(text,record)=>{
      return <div>
        <Button type='link start-color' onClick={()=> this.handleStart(record.id,record.status)}>{record.status==0?'启用':'封停'}</Button>
        <Button type='link ' onClick={()=> this.handleEditPwd(record)}>重置密码</Button>
        <Popconfirm
        title="你确定删除吗?"
        onConfirm={()=> this.handleDelete(record)}
        //onCancel={this.cancel}
        okText="Yes"
        cancelText="No"
        >
            <Button type='link ml-20 delete-red' >删除</Button>
        </Popconfirm>
        
      </div>
    }},
  ];
  handleStart(id,status){
      
    return HttpClient.post(Api.setUserStatus,{id:id,status:status==1?2:1}).then(data => {
        this.getList(this.defaultParams);
    })
  }
  handleEditPwd=(list)=>{
      this.setState({
          visible_edit:true,
          list:list
      })
  }
  handleDelete=(record)=>{
    return HttpClient.post(Api.deleteUserList,{id:record.id}).then(data => {
        if(data){
            message.success('删除成功！');
            this.getList(this.defaultParams)
        }
        
        
        // this.setState({
        //   dataSource: data,
        // })
      })
  }
  getList(params){
    return HttpClient.post(Api.getUserList,{...params}).then(data => {
      this.setState({
        dataSource: data,
      })
    })
  }


  
  
  pager = (page) => {
    this.defaultParams = Object.assign({},this.defaultParams,{page_index:page});
    this.getList(this.defaultParams);
  };
  getTableQuery=(params)=>{
   
      this.defaultParams = Object.assign(this.defaultParams,{...params});
   
    this.getList(this.defaultParams);
  };
//   resetParams = ()=>{
//     this.defaultParams = {};
//     this.setState({
//       tableData:{}
//     })
//   };

  handleCancel = () => {
    this.setState({ visible: false,visible_edit:false });
  };
  handleOk=()=>{
      
    this.props.form.validateFields((err, values) => {
        console.log(values)
      if (!err) {
        console.log('Received values of form: ', values);
        HttpClient.post(Api.addUser,{...values}).then(data => {
            this.setState({ visible: false });
            this.getList(this.defaultParams)
          })
      }
    });
   
  }
  handleOkEdit=()=>{
    this.props.form.validateFields((err, values) => {
        HttpClient.post(Api.rePwd,{id:values.id,pwd:values.pwd}).then(data => {
           if(data){
               message.success('操作成功！')
            this.setState({ visible_edit: false });
            this.getList(this.defaultParams)
           }
            
          })
    });
  }
  getExcel = () => {
   // window.open(parseParams(Api.crm_order,Object.assign(this.defaultParams,{api_token:get('token'),export:1})));
  };
 
  showBatchModal = (list) => {
      if(list){
        this.setState({visible: true,list:list,title:'编辑用户'});
      }else{
        this.setState({visible: true,title:'新增用户'});
      }
    
  };
  

  componentDidMount() {
    this.getList(this.defaultParams)
  }

  render() {
    const itemTableQuery= [
         
      {
        type:'input',
        key:'key',
       placeholder:'请输入姓名'
      },
     
      {
        type: "submit",
        extend: false,
        // render: <Fragment>
          
        //   </Fragment>,
      },
    ];
    const { getFieldDecorator } = this.props.form;
    const formItemLayout = {
      labelCol: {
        xs: { span: 24 },
        sm: { span: 8 },
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 12 },
      },
    };
   const {list,title}=this.state;
    return(
      <Fragment>
            <ItemNav itemNav={this.itemNav} />
            <section className='content-base'>
          <div className='mb-20 formwrapper'>
            <div className='formBg'><ItemTableQuery getTableQuery={this.getTableQuery} resetParams={this.resetParams} itemTableQuery={itemTableQuery} /></div>
            <Button type='primary' className='ml-20' onClick={()=> this.showBatchModal()}>添加</Button>
          </div>
         
          <ItemTable columns={this.columns} dataSource={this.state.dataSource} pager={this.pager} />
        </section>
        <Modal  title={title}
          visible={this.state.visible}
          onOk={this.handleOk}
          onCancel={this.handleCancel}>
            <Form {...formItemLayout} >

              <Form.Item label="姓名">
              {getFieldDecorator('name', {
               // initialValue:list?list.name:'',
                rules: [
                  {
                    required: true,
                    message: '请选择',
                  },
                ],
                })(
                <Input/>
                )}
              </Form.Item>
              <Form.Item label="真实姓名">
              {getFieldDecorator('realName', {
               // initialValue:list?list.realName:'',
                rules: [
                  {
                    required: true,
                    message: '请选择',
                  },
                ],
                })(
                <Input/>
                )}
              </Form.Item>
              <Form.Item label="密码">
              {getFieldDecorator('pwd', {
               // initialValue:list?list.pwd:'',
                rules: [
                  {
                    required: true,
                    message: '请选择',
                  },
                ],
                })(
                <Input type='password'/>
                )}
              </Form.Item>
              <Form.Item label="手机号">
              {getFieldDecorator('phone', {
               // initialValue:list?list.phone:'',
                // rules: [
                //   {
                //     required: true,
                //     message: '请选择',
                //   },
                // ],
                })(
                <Input type='phone'/>
                )}
              </Form.Item>
              <Form.Item label="邮箱">
              {getFieldDecorator('email', {
               // initialValue:list?list.email:'',
                // rules: [
                //   {
                //     required: true,
                //     message: '请选择',
                //   },
                // ],
                })(
                <Input type='email'/>
                )}
              </Form.Item>
              <Form.Item label="备注">
              {getFieldDecorator('remark', {
               // initialValue:list?list.remark:'',
                // rules: [
                //   {
                //     required: true,
                //     message: '请选择',
                //   },
                // ],
                })(
                <Input type='text'/>
                )}
              </Form.Item>
            </Form>
        </Modal>
        <Modal  title={title}
          visible={this.state.visible_edit}
          onOk={this.handleOkEdit}
          onCancel={this.handleCancel}>
            <Form {...formItemLayout} >

              <Form.Item label="用户ID">
              {getFieldDecorator('id', {
                initialValue:list?list.id:'',
                rules: [
                  {
                    required: true,
                    message: '请选择',
                  },
                ],
                })(
                <Input disabled/>
                )}
              </Form.Item>
              <Form.Item label="密码">
              {getFieldDecorator('pwd', {
               // initialValue:list?list.realName:'',
                rules: [
                  {
                    required: true,
                    message: '请选择',
                  },
                ],
                })(
                <Input/>
                )}
              </Form.Item>
              
            </Form>
        </Modal>
      </Fragment>
    )
  }
}
export default Form.create()(User)