import axios from 'axios';
import {get,set,clear} from "./Global";
import {hasIt} from './utils';
import { message } from 'antd';
//取消请求

let CancelToken = axios.CancelToken;
axios.create({
    timeout: 15000,// 请求超时时间
    headers: {
        'Content-Type': 'application/x-www-form-urlencoded',
    },
});
const error = (msg) => {
    message.error(msg);
};

//开始请求设置，发起拦截处理
axios.interceptors.request.use(config => {
    if(!hasIt('login', config.url)){
        let token = get('token');
        if (token) {
            if(get('overdue_data') < Date.now()){
                clear();
                window.location.href='/#/login';
                return
            }
            config.headers.token=token
        } else {
            window.location.href='/#/login';
        }
    }
    let requestName = config.method;
    return config
}, error => {
    return Promise.reject(error)
});
// respone拦截器
axios.interceptors.response.use(
    response => {
        const res = response.data;
        //这里根据后台返回来设置
        if (res.code === '200') {
            return res.data;
        } else {
            error(res.msg);
            if(res.code==402){
                clear();
                window.location.href='/#/login';
            }
            return false;
        }
    },
    error => {
        console.log(error)
      if(hasIt('402', error.toString())){
        message.error('token超时,请重新登录!',1,()=>{
          clear();
          window.location.href='/#/login';
        });
      }
        return Promise.reject(error)
    }
);

export default axios;
